﻿using System;
using Stimulsoft.Report;
using System.Reflection;
using System.IO;
using Stimulsoft.Report.Export;
using Stimulsoft.Base;
using System.Data;

namespace UEReport
{
    class Program
    {
        static void Main(string[] args)
        {
            //const string PATH = "E:\\prosjekt\\backend-report.pdf";
            const string PATH = "E:\\backend-report.pdf";

            Console.WriteLine("Report generation testing");

            Assembly assembly = Assembly.GetExecutingAssembly();
            StiReport report = new StiReport();
            report.LoadDocument(assembly.GetManifestResourceStream(string.Format("{0}.CustomerInvoiceWithoutGiro.mrt", assembly.GetName().Name)));

            Stream template = assembly.GetManifestResourceStream(string.Format("{0}.Data.json", assembly.GetName().Name));
            MemoryStream ms = new MemoryStream();
            template.CopyTo(ms);
            DataSet dataset = StiJsonToDataSetConverter.GetDataSet(ms.ToArray());

            report.RegData("Data", "Data", dataset);
            report.Dictionary.Synchronize();
            report.Render(false);

            var settings = new StiPdfExportSettings();
            var service = new StiPdfExportService();

            var stream = new MemoryStream();
            service.ExportTo(report, stream, settings);

            stream.Position = 0;
            File.WriteAllBytes(PATH, stream.ToArray());

            Console.WriteLine("Report file written to " + PATH);
            Console.WriteLine("Any key to exit");
            Console.ReadKey();
        }
    }
}
